"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * hornet-js-batch - Ensemble des composants de gestion de base hornet-js
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.2.3
 * @link git+https://github.com/diplomatiegouvfr/hornet-js.git
 * @license CECILL-2.1
 */
var hornet_js_utils_1 = require("hornet-js-utils");
var promise_api_1 = require("hornet-js-utils/src/promise-api");
var batch_status_1 = require("hornet-js-batch/src/core/batch-status");
var uuid = require("uuid");
var logger = hornet_js_utils_1.Utils.getLogger("hornet-js-batch.batch-process");
var BatchProcess = /** @class */ (function () {
    function BatchProcess(config) {
        this._options = {};
        this._status = batch_status_1.STATUS.INIT;
        this._options.config = config;
    }
    Object.defineProperty(BatchProcess.prototype, "result", {
        get: function () {
            return this._result;
        },
        set: function (result) {
            this._result = result;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BatchProcess.prototype, "total", {
        get: function () {
            return this._total;
        },
        set: function (total) {
            this._total = total;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BatchProcess.prototype, "list", {
        get: function () {
            return this._list;
        },
        set: function (list) {
            this._list = list;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BatchProcess.prototype, "name", {
        get: function () {
            return this._name || this.constructor["name"];
        },
        set: function (name) {
            this._name = name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BatchProcess.prototype, "idBatch", {
        get: function () {
            return this._idBatch;
        },
        set: function (id) {
            this._idBatch = id;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BatchProcess.prototype, "batch", {
        get: function () {
            return this._batch;
        },
        set: function (batch) {
            this._batch = batch;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BatchProcess.prototype, "options", {
        get: function () {
            return this._options;
        },
        set: function (options) {
            this._options = options;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BatchProcess.prototype, "status", {
        get: function () {
            return this._status;
        },
        set: function (status) {
            this._status = status;
            this._batch.updateStatus();
            if (status === batch_status_1.STATUS.FAILED || status === batch_status_1.STATUS.SUCCEEDED) {
                if (this.timer) {
                    clearInterval(this.timer);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    BatchProcess.prototype.print = function () {
        if (this.list && this._total) {
            var calc = 100 - ((100.0 * this.list.length) / this._total);
            logger.trace(this.name + " " + calc.toFixed(2));
        }
    };
    BatchProcess.prototype.execute = function () {
        var timer = hornet_js_utils_1.Utils.config.getOrDefault("batch.printTimer", 500);
        this.status = batch_status_1.STATUS.RUNNING;
        this.timer = setInterval(this.print.bind(this), timer);
        return this.treatment();
    };
    return BatchProcess;
}());
exports.BatchProcess = BatchProcess;
var BatchProcessParent = /** @class */ (function (_super) {
    tslib_1.__extends(BatchProcessParent, _super);
    function BatchProcessParent(child) {
        var _this = _super.call(this, null) || this;
        _this.child = child;
        return _this;
    }
    Object.defineProperty(BatchProcessParent.prototype, "idBatch", {
        set: function (id) {
            this.child.forEach(function (value) {
                value.idBatch = id;
            });
            this._idBatch = "ProcessParent";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BatchProcessParent.prototype, "batch", {
        set: function (batch) {
            this.child.forEach(function (value) {
                value.batch = batch;
            });
            this._batch = batch;
        },
        enumerable: true,
        configurable: true
    });
    BatchProcessParent.prototype.updateStatus = function () {
        var _this = this;
        var res = this.child.reduce(function (result, process) {
            var res = false;
            var status = process.status;
            if (status === batch_status_1.STATUS.SUCCEEDED) {
                res = true;
            }
            else {
                _this.status = status;
            }
            return result && res;
        }, true);
        if (res) {
            this.status = batch_status_1.STATUS.SUCCEEDED;
        }
    };
    BatchProcessParent.prototype.treatment = function () {
        var _this = this;
        var promises = [];
        //
        this.child.forEach(function (value) {
            value.options.arg = _this.options.args;
            promises.push(value.execute());
        });
        return promise_api_1.Promise.all(promises).then(function (result) {
            var res = [];
            result.forEach(function (value, index) {
                res = res.concat(value);
            });
            _this.status = batch_status_1.STATUS.SUCCEEDED;
            _this.result = res;
            return _this.result;
        });
    };
    return BatchProcessParent;
}(BatchProcess));
exports.BatchProcessParent = BatchProcessParent;

//# sourceMappingURL=batch-process.js.map
